#include	<SerialPort.h>
#include	<AppKit.h>

#define	i2764		0
#define	i27128	1
#define	i27256	2
#define	i2864		3

#define	CWRwithTX		1
#define	CWRfromAKIRAM	2
#define	CTXtoAKIRAM	3
#define	CRDandRX		4
#define	CRDtoAKIRAM	5
#define	CCMPHEXFile	6
#define	CCMP_AKIRAM	7
#define	CBlankCheck	8
#define	CCSUM		9

#define	AKI_OK		0
#define	AKI_OPEN_ERR	-1
#define	AKI_RS_NOTRDY	-2
#define	AKI_NOT_RDY	-3
#define	AKI_INV_ROM	-4
#define	AKI_INV_ADR	-5
#define	AKI_ERROR		-6
#define	AKI_NOT_BLANKROM	-7

extern unsigned int	HexToInt(const char *hex);

class		TAKIROMRS : public	BLooper
{
public:
			TAKIROMRS(BLooper *Target,BMessage *Message);
			~TAKIROMRS();
	void		MessageReceived(BMessage *msg);

	int		AKICheckOpen();
	int		SetStartEndAdr(int SAdr,int EAdr);
	int		CheckAdr(int sa,int ea);
	int		GetStartAdr();
	int		GetEndAdr();
	int		GetSize();
	int		LoadBinFile(entry_ref *ref);
	int		LoadHexFile(entry_ref *ref);
	int		SaveBinFile(const char *path);
	int		SaveHexFile(const char *path);
	int		CheckSum();
	int		romCmd( char cmd );
	int		txSize();
	int		Recv( char *s,int i );
	int		Send( char *s,int i );
	void		AKIProcessStart( char *msg );
	void		AKIProcessEnd( char *msg,int result );
	void		AKIProcessAbort( int errcode );

	void		BlankCheck();
	void		TransmitToAKIRAM();
	void		WritefromAKIRAM();
	void		WriteAndTransmit();
	void		ReadToAKIRAM();
	void		ReadAndReceive();
	void		CompareFile();
	void		CompareAKIRAM();

	int		_BlankCheck();
	int		_TransmitToAKIRAM();
	int		_WritefromAKIRAM();
	int		_WriteAndTransmit();
	int		_ReadToAKIRAM();
	int		_ReadAndReceive();
	int		_CompareFile();
	int		_CompareAKIRAM();

	char		RomBuff[65536];
	char		devName[256];
	int		RomType;

private:
	BSerialPort	serial;

	BMessage	*BlankCheckMsg;
	BMessage	*TransmitMsg;
	BMessage	*WriteRamMsg;
	BMessage	*WandTMsg;
	BMessage	*ReadRAMMsg;
	BMessage	*ReadRcvMsg;
	BMessage	*CmpFileMsg;
	BMessage	*CmpRAMMsg;

	BLooper	*MessageTarget;
	BMessage	*InfoMessage;

	int		StartAdr;
	int		EndAdr;
	int		Size;

	bool		Batch;
};
