#include	"AKIROMView.h"

TAKIROMView::TAKIROMView( BRect vframe ) : BView( vframe , "akiromview" , B_FOLLOW_ALL , B_WILL_DRAW )
{
BRect		frame;
BMenuItem		*item;
char			devName[B_OS_NAME_LENGTH];
BSerialPort	serial;
int			i;

	frame.Set(150,23,270,38);
	StartAdr = new BTextControl(frame,"sadr","Start Address :","0000",NULL,B_FOLLOW_ALL,B_WILL_DRAW);
	StartAdr->SetDivider(80);
	AddChild( StartAdr );
	frame.Set(150,43,270,58);
	EndAdr = new BTextControl(frame,"eadr","End Address :","7FFF",NULL,B_FOLLOW_ALL,B_WILL_DRAW);
	EndAdr->SetDivider(80);
	AddChild( EndAdr );

	PortMenu = new BMenu("no serial");
	PortMenu->SetLabelFromMarked(true);
	PortMenu->SetRadioMode(true);
	for	(i = serial.CountDevices()-1; i >= 0; i--) {
		serial.GetDeviceName(i, devName);
		item = new BMenuItem( devName , NULL );
		item->SetMarked(true);
		PortMenu->AddItem(item);
	};
	frame.Set(10,22,150,42);
	SerialPort = new BMenuField(frame,"SerialPort","SerialPort",PortMenu);
	SerialPort->SetDivider(60);
	AddChild(SerialPort);

	RomMenu = new BMenu("27256");
	RomMenu->SetLabelFromMarked(true);
	RomMenu->SetRadioMode(true);
	item = new BMenuItem( "2764" , new BMessage(MENU_ROMSELECT_MSG) );
	RomMenu->AddItem(item);
	item = new BMenuItem( "27128" , new BMessage(MENU_ROMSELECT_MSG) );
	RomMenu->AddItem(item);
	item = new BMenuItem( "27256" , new BMessage(MENU_ROMSELECT_MSG) );
	item->SetMarked(true);
	RomMenu->AddItem(item);
	item = new BMenuItem( "2864" , new BMessage(MENU_ROMSELECT_MSG) );
	RomMenu->AddItem(item);
	frame.Set(10,44,150,64);
	RomType = new BMenuField(frame,"RomType","RomType",RomMenu);
	RomType->SetDivider(60);
	AddChild(RomType);

	frame.Set(15,64,75,84);
	infileLabel = new BStringView(frame,"infileLabel","In file  = ");
	AddChild(infileLabel);
	frame.Set(80,64,120,84);
	infileMode = new BStringView(frame,"infileMode","<???>");
	AddChild(infileMode);
	frame.Set(125,64,300,84);
	infileName = new BStringView(frame,"infileName","");
	AddChild(infileName);

	frame.Set(20,220,380,230);
	StatusLabel = new BStringView(frame,"statusview","Select ROM Type and SerialPort.");
	AddChild(StatusLabel);

	frame.Set(20,90,140,110);
	BlankCheckBtn = new BButton(frame,"bchk","Blank Check",new BMessage(BTN_BLANKCHECK_MSG));
	AddChild(BlankCheckBtn);

	frame.Set(20,120,140,140);
	TransmitBtn = new BButton(frame,"trns","Transmit to AKI-RAM",new BMessage(BTN_TRANSMIT_MSG));
	AddChild(TransmitBtn);

	frame.Set(20,150,140,170);
	WriteBtn = new BButton(frame,"writ","Write from AKI-RAM",new BMessage(BTN_WRITERAM_MSG));
	AddChild(WriteBtn);

	frame.Set(20,180,140,200);
	WandTBtn = new BButton(frame,"tandw","Write & Transmit",new BMessage(BTN_WANDT_MSG));
	AddChild(WandTBtn);

	frame.Set(150,90,270,110);
	ReadAKIRAMBtn = new BButton(frame,"rram","Read to AKI-RAM",new BMessage(BTN_READRAM_MSG));
	AddChild(ReadAKIRAMBtn);

	frame.Set(150,120,270,140);
	ReadRcvBtn = new BButton(frame,"rrcv","Read & Receive",new BMessage(BTN_READRCV_MSG));
	AddChild(ReadRcvBtn);

	frame.Set(150,150,270,170);
	CompareFileBtn = new BButton(frame,"cfil","Compare File",new BMessage(BTN_CMPFILE_MSG));
	AddChild(CompareFileBtn);

	frame.Set(150,180,270,200);
	CompareRAMBtn = new BButton(frame,"cram","Compare AKI-RAM",new BMessage(BTN_CMPRAM_MSG));
	AddChild(CompareRAMBtn);
}
