#include	<Path.h>
#include	"AKIROMApp.h"
#include	"AKIROMWin.h"


TAKIROMWin::TAKIROMWin( BRect frame ):BWindow( frame, "AKI-ROMWriter" , B_TITLED_WINDOW , B_NOT_RESIZABLE | B_NOT_ZOOMABLE )
{
BMenuItem	*item;

	Working = false;

	View = new TAKIROMView( Bounds() );
	AKIROMRS = new TAKIROMRS(this,new BMessage(AKIROM_INFO_MSG));

	OpenHexPanel = new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false,NULL,NULL,false);
	OpenHexPanel->SetMessage( new BMessage(REFS_HEXLOAD_MSG) );
	OpenHexPanel->SetTarget(this);
	OpenBinPanel = new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false,NULL,NULL,false);
	OpenBinPanel->SetMessage( new BMessage(REFS_BINLOAD_MSG) );
	OpenBinPanel->SetTarget(this);
	SaveHexPanel = new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false,NULL,NULL,false);
	SaveHexPanel->SetMessage( new BMessage(SAVE_HEXSAVE_MSG) );
	SaveHexPanel->SetTarget(this);
	SaveBinPanel = new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false,NULL,NULL,false);
	SaveBinPanel->SetMessage( new BMessage(SAVE_BINSAVE_MSG) );
	SaveBinPanel->SetTarget(this);


	MenuBar = new BMenuBar( BRect(0,0,100,20),"MenuBar");

	filemenu = new BMenu("File");
	item = new BMenuItem( "Load BIN File",new BMessage(MENU_LOADBIN_MSG));
	item->SetTarget(this);
	filemenu->AddItem(item);
	item = new BMenuItem( "Load HEX File",new BMessage(MENU_LOADHEX_MSG));
	item->SetTarget(this);
	filemenu->AddItem(item);
	item = new BMenuItem( "Save BIN File",new BMessage(MENU_SAVEBIN_MSG));
	item->SetTarget(this);
	filemenu->AddItem(item);
	item = new BMenuItem( "Save HEX File",new BMessage(MENU_SAVEHEX_MSG));
	item->SetTarget(this);
	filemenu->AddItem(item);
	item = new BMenuItem( "Quit",new BMessage(B_QUIT_REQUESTED));
	item->SetTarget(this);
	filemenu->AddItem(item);
	MenuBar->AddItem(filemenu);

	AddChild(MenuBar);
	AddChild( View );

	AKIROMRS->Run();
}

bool	TAKIROMWin::QuitRequested()
{
	if ( Working == true ) {
		BAlert *alert = new BAlert("","AKI-Writer is working. Do you want to quit now?","Quit","Cancel");
		if  ( alert->Go() != 0 ) { return false; };
	};
	AKIROMRS->PostMessage( B_QUIT_REQUESTED );
	be_app->PostMessage( B_QUIT_REQUESTED );
	return	true;
}

void	TAKIROMWin::MessageReceived( BMessage *msg )
{
BMenuItem		*item;
entry_ref		ref;
const char	*name;
BPath		path;
BEntry		entry;
BAlert		*alert;
const char	*info;
char			amsg[256];
//int32	proc;

	switch( msg->what ) {
		case	MENU_ROMSELECT_MSG:
			item = View->RomMenu->FindMarked();
			if ( item != NULL ) {
				if ( strcmp(item->Label(),"2764") == 0 )  {
					AKIROMRS->RomType = 0;
					View->StartAdr->SetText("0000");
					View->EndAdr->SetText("1FFF");
				};
				if ( strcmp(item->Label(),"27128") == 0 ) {
					AKIROMRS->RomType = 1;
					View->StartAdr->SetText("0000");
					View->EndAdr->SetText("3FFF");
				};
				if ( strcmp(item->Label(),"27256") == 0 ) {
					AKIROMRS->RomType = 2;
					View->StartAdr->SetText("0000");
					View->EndAdr->SetText("7FFF");
				};
				if ( strcmp(item->Label(),"2864") == 0 )  {
					AKIROMRS->RomType = 3;
					View->StartAdr->SetText("0000");
					View->EndAdr->SetText("1FFF");
				};
			};
			break;
		case	AKIROM_INFO_MSG:
			info = msg->FindString("info");
//			proc = msg->FindInt32("proc");
			sprintf(amsg,"%s",info);
			View->StatusLabel->SetText(amsg);
			if ( msg->FindBool("endf") == true ) {
				AKIEnable(true);
			}
			break;
		case	MENU_LOADBIN_MSG:
			if ( OpenBinPanel->IsShowing() == true ) {
				OpenBinPanel->Window()->Activate();
			} else {
				OpenBinPanel->Show();
			};
			break;
		case	MENU_LOADHEX_MSG:
			if ( OpenHexPanel->IsShowing() == true ) {
				OpenHexPanel->Window()->Activate();
			} else {
				OpenHexPanel->Show();
			};
			break;
		case	MENU_SAVEBIN_MSG:
			if ( SaveBinPanel->IsShowing() == true ) {
				SaveBinPanel->Window()->Activate();
			} else {
				SaveBinPanel->Show();
			};
			break;
		case	MENU_SAVEHEX_MSG:
			if ( SaveHexPanel->IsShowing() == true ) {
				SaveHexPanel->Window()->Activate();
			} else {
				SaveHexPanel->Show();
			};
			break;
		case	REFS_BINLOAD_MSG:
			if ( msg->FindRef( "refs",0,&ref ) != B_OK ) { break; };
			if ( AKIROMRS->LoadBinFile(&ref) < 0 ) {
				alert = new BAlert("","Load error!","OK");
				alert->Go();
			} else {
				View->infileMode->SetText( "<BIN>" );
				View->infileName->SetText( ref.name );
			};
			break;
		case	REFS_HEXLOAD_MSG:
			if ( msg->FindRef( "refs",0,&ref ) != B_OK ) { break; };
			if ( AKIROMRS->LoadHexFile(&ref) != 0 ) {
				alert = new BAlert("","Load error!","OK");
				alert->Go();
			} else {
				View->infileMode->SetText( "<HEX>" );
				View->infileName->SetText( ref.name );
			};
			break;
		case	SAVE_BINSAVE_MSG:
			if ( msg->FindRef( "directory",0,&ref ) != B_OK ) { break; };
			if ( msg->FindString( "name",0,&name ) != B_OK ) { break; };
			if ( entry.SetTo(&ref) != B_OK ) { break; };
			entry.GetPath(&path);
			path.Append(name);
			AKIROMRS->SaveBinFile(path.Path());
			break;
		case	SAVE_HEXSAVE_MSG:
			if ( msg->FindRef( "directory",0,&ref ) != B_OK ) { break; };
			if ( msg->FindString( "name",0,&name ) != B_OK ) { break; };
			if ( entry.SetTo(&ref) != B_OK ) { break; };
			entry.GetPath(&path);
			path.Append(name);
			AKIROMRS->SaveHexFile(path.Path());
			break;
		case	BTN_BLANKCHECK_MSG:
			AKIEnable(false);
			AKIROMRS->BlankCheck();
			break;
		case	BTN_TRANSMIT_MSG:
			AKIEnable(false);
			AKIROMRS->TransmitToAKIRAM();
			break;
		case	BTN_WRITERAM_MSG:
			AKIEnable(false);
			AKIROMRS->WritefromAKIRAM();
			break;
		case	BTN_WANDT_MSG:
			AKIEnable(false);
			AKIROMRS->WriteAndTransmit();
			break;
		case	BTN_READRAM_MSG:
			AKIEnable(false);
			AKIROMRS->ReadToAKIRAM();
			break;
		case	BTN_READRCV_MSG:
			AKIEnable(false);
			AKIROMRS->ReadAndReceive();
			break;
		case	BTN_CMPFILE_MSG:
			AKIEnable(false);
			AKIROMRS->CompareFile();
			break;
		case	BTN_CMPRAM_MSG:
			AKIEnable(false);
			AKIROMRS->CompareAKIRAM();
			break;
		default:
			inherited::MessageReceived( msg );
	}	
}

void	TAKIROMWin::AKIEnable(bool enable)
{
BMenuItem		*MenuItem;

	MenuItem = View->PortMenu->FindMarked();
	if ( MenuItem != NULL ) {
		strcpy(AKIROMRS->devName,MenuItem->Label());
	} else {
		return;
	};
	View->BlankCheckBtn->SetEnabled(enable);
	View->TransmitBtn->SetEnabled(enable);
	View->WriteBtn->SetEnabled(enable);
	View->WandTBtn->SetEnabled(enable);
	View->ReadAKIRAMBtn->SetEnabled(enable);
	View->ReadRcvBtn->SetEnabled(enable);
	View->CompareFileBtn->SetEnabled(enable);
	View->CompareRAMBtn->SetEnabled(enable);
	View->StartAdr->SetEnabled(enable);
	View->EndAdr->SetEnabled(enable);
	MenuBar->SetEnabled(enable);
	AKIROMRS->SetStartEndAdr(HexToInt(View->StartAdr->Text()),HexToInt(View->EndAdr->Text()));
	Working = !enable;
}
